#include "DoubleAudio.h"

void double_audio_new(DoubleAudio **p_this, ulong n, ulong rate) {
  DoubleAudio *this;

  if (n == 0) {
    throw("Number of samples must be nonzero");
  }

  if (rate == 0) {
    throw("Sample rate must be nonzero");
  }

  this = newo(p_this);

  this->n = n;
  this->rate = rate;
  new(&this->_samples, n);
}

void double_audio_delete(DoubleAudio **p_this) {
  DoubleAudio *this;

  if ((this = *p_this) == null) {
    return;
  }

  deletev(&this->_samples);

  deleteo(p_this);
}

void double_audio_print(DoubleAudio *this, Printer *p) {
  ulong u;

  sprint(p, "DoubleAudio");
  rprint(p, "Number of samples: %lu", this->n);
  rprint(p, "Sample rate: %lu Hz", this->rate);

  sprint(p, "Samples");

  for (u = 0; u < this->n; u++) {
    rprint(p, "[%lu] %.16g", u, this->_samples[u]);
  }

  fprint(p);
  fprint(p);
}
