/* Internal representation of an audio file. Full intensity is between -1.0 and
 * +1.0. The rate is the sample rate in hertz.
 */
#ifndef DOUBLE_AUDIO_H
#define DOUBLE_AUDIO_H

#ifdef __cplusplus
extern "C" {
#endif

#include "jpc.h"

typedef struct {
  ulong rate;
  ulong n;
  double *_samples;
} DoubleAudio;

/* Constructor.
 */
void double_audio_new(DoubleAudio **p_this, ulong n, ulong rate);

/* Destructor.
 */
void double_audio_delete(DoubleAudio **p_this);

/* Print.
 */
void double_audio_print(DoubleAudio *this, Printer *p);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* _H */
