/* Static library providing a method for applying Magic Kernel Sharp and
 * related kernels to resample a DoubleAudio.
 */
#ifndef MAGIC_DOUBLE_AUDIO_H
#define MAGIC_DOUBLE_AUDIO_H

#ifdef __cplusplus
extern "C" {
#endif

#include "double_audio_kernel.h"
#include "magic.h"

/* Resample a DoubleAudio to a new sampling rate. If extra_antialiasing is
 * true, and we are downsampling, then MKS is applied to the input signal with
 * twice the regular width, which moves the half-height frequency to half the
 * new Nyquist frequency, so that there is now a sixth-order zero at the new
 * Nyquist frequency, as well as its multiples (including multiples of the new
 * sampling frequency).
 */
DoubleAudio *double_audio_new_resample(
    DoubleAudio **p_this,
    DoubleAudio *other,
    ulong new_rate,
    bool extra_antialiasing);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* _H */
