/* Static library providing methods for writing a DoubleAudio to and reading
 * from single-channel 16-bit PCM WAV files.
 */
#ifndef WAV_FILE_H
#define WAV_FILE_H

#ifdef __cplusplus
extern "C" {
#endif

#include "DoubleAudio.h"
#include "File.h"

/* Load a DoubleAudio from a 16-bit PCM WAV file.
 */
DoubleAudio *double_audio_new_load_wav(DoubleAudio **p_this, char *filename);

/* Save a DoubleAudio to a 16-bit PCM WAV file.
 */
void double_audio_save_wav(DoubleAudio *this, char *filename);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* _H */
