#include "resample_wav.h"

int main(int argc, char *argv[]) {
  bool extra_antialiasing;
  char *in_filename;
  char *out_filename;
  uint rate_out;
  DoubleAudio *_in = null;
  DoubleAudio *_out = null;

  args_description("Resample a 16-bit PCM WAV file");
  args_string("input-filename", "Input 16-bit PCM WAV file");
  args_integer("output-rate", "New sample rate in hertz");
  args_string("output-filename", "Output WAV file to create");
  args_flag("extra-antialiasing",
      'e',
      "Apply extra antialiasing on downsampling by halving the width "
      "of the low-pass filter in frequency space, so that there is a "
      "sixth-order zero at the Nyquist frequency");
  args_parse(argc, argv);

  in_filename = args_get_string("input-filename");
  rate_out = args_get_bounded_integer("output-rate", 1, UINT_MAX);
  out_filename = args_get_string("output-filename");
  extra_antialiasing = args_get_flag("extra-antialiasing");

  double_audio_new_load_wav(&_in, in_filename);
  double_audio_new_resample(&_out, _in, rate_out, extra_antialiasing);
  double_audio_delete(&_in);
  double_audio_save_wav(_out, out_filename);
  double_audio_delete(&_out);

  return 0;
}
