#include "DoubleAudioTest.h"
#include <limits.h>

START

TEST(DoubleAudio, New) {
  DoubleAudio *_ = null;

  double_audio_new(&_, 1, 1);
  EXPECT_ULEQ(1, _->n);
  EXPECT_ULEQ(1, _->rate);
  EXPECT_DEQ(0, _->_samples[0]);
  double_audio_delete(&_);

  double_audio_new(&_, 2, 1);
  EXPECT_ULEQ(2, _->n);
  EXPECT_ULEQ(1, _->rate);
  EXPECT_DEQ(0, _->_samples[0]);
  EXPECT_DEQ(0, _->_samples[1]);
  double_audio_delete(&_);

  double_audio_new(&_, 1, 2);
  EXPECT_ULEQ(1, _->n);
  EXPECT_ULEQ(2, _->rate);
  EXPECT_DEQ(0, _->_samples[0]);
  double_audio_delete(&_);

  double_audio_new(&_, 3, ULONG_MAX);
  EXPECT_ULEQ(3, _->n);
  EXPECT_ULEQ(ULONG_MAX, _->rate);
  EXPECT_DEQ(0, _->_samples[0]);
  EXPECT_DEQ(0, _->_samples[1]);
  EXPECT_DEQ(0, _->_samples[2]);
  double_audio_delete(&_);
}

TEST(DoubleAudio, Print) {
  char *_s = null;
  DoubleAudio *_ = null;

  double_audio_new(&_, 2, 44100);
  _->_samples[0] = 0.34;
  _->_samples[1] = -0.12;
  aprint(&_s, 0, double_audio, _);
  EXPECT_STREQ(
      "[DoubleAudio]\n. Number of samples: 2\n. Sample rate: 44,100 Hz\n"
      ". [Samples]\n. . [0] 0.34\n. . [1] -0.12\n. [/Samples]\n"
      "[/DoubleAudio]\n",
      _s);
  string_delete(&_s);

  double_audio_delete(&_);
}

FINISH
